#include <stdio.h>
#include <stdlib.h>
#include "kp.h"


kp_t *lire_kp(char *fichier)
{  FILE *fp;
   kp_t *kp;
   int n, i, j;
   
   kp = malloc(sizeof(kp_t));
   fp = fopen(fichier, "r");
   fscanf(fp, "%d", &n);
   kp->n = n;
   kp->c = malloc((n + 1) * sizeof(int));
   kp->a = malloc((n + 1) * sizeof(int));
   for (i = 0; i < n; i++)
   {  fscanf(fp, "%d", &j);
      fscanf(fp, "%d%d", kp->c + j, kp->a + j);
   }
   fscanf(fp, "%d", &kp->b);
   fclose(fp);
   return kp;
}


void free_kp(kp_t *kp)
{  free(kp->c);
   free(kp->a);
   free(kp);
}


/* structure utilise pour trier les objets */
typedef struct
{  double ratio;
   int index;
} ri_t;


/* fonction auxiliaire de tri */
int cmp(const void *a, const void *b)
{  double x = ((ri_t *)a)->ratio;
   double y = ((ri_t *)b)->ratio;
   
   if (x > y) return -1;
   if (x < y) return 1;
   return 0;
}



void trier_objets(kp_t *kp, sp_t sp)
{  ri_t *ri;
   int j, n_obj;

   ri = malloc(kp->n * sizeof(ri_t));
   n_obj = 0;
   for (j = 1; j <= kp->n; j++)
      if (kp->a[j] <= kp->b)
      {  ri[n_obj].ratio = (double)kp->c[j] / kp->a[j];
         ri[n_obj].index = j;
         n_obj++;
      }
   qsort(ri, n_obj, sizeof(ri_t), cmp);
   C(sp) = 0;
   B(sp) = kp->b;
   NLIB(sp) = n_obj;
   NFIX1(sp) = 0;
   for (j = 0; j < n_obj; j++)
      LIB(sp)[j] = ri[j].index;
}


void sol_glouton(kp_t *kp, sp_t sp, sp_t sol)
{  int i, j;

   C(sol) = C(sp);
   B(sol) = B(sp);
   NLIB(sol) = 0;
   NFIX1(sol) = 0;
   for (i = 0; i < NLIB(sp); i++)
   {  j = LIB(sp)[i];
      if (kp->a[j] <= B(sol))
      {  C(sol) += kp->c[j];
         B(sol) -= kp->a[j];
	 FIX1(sol)[NFIX1(sol)] = j;
	 NFIX1(sol)++;
      }
   }
   for (i = 0; i < NFIX1(sp); i++)
   {  FIX1(sol)[NFIX1(sol)] = FIX1(sp)[i];
      NFIX1(sol)++;
   }
}
