#ifndef POOL_H

#define POOL_H

/* structures de donnes et fonctions de gestion du pool de sous-problmes */

#include "kp.h"

/* structure utilise pour representer le pool de sous-problmes
   cette implementation est un tableu de taille variable
   le pool est une pile (LIFO)
*/
typedef struct
{  int n;    /* nombre courant d'lments */
   int cap;  /* taille max */
   sp_t *sp; /* tableau de sous-problmes */
}  pool_t;

/* capacit initiale du pool */
#define CAPACITE_INITIALE 1000

/* initialisation du pool */
pool_t *p_init();

/* nettoyage du pool */
void p_free(pool_t *pool);

/* verifie si le pool est vide */
int p_isempty(pool_t *p);


/* ajout d'un lment au pool
   le nouveau lment est ajout  la fin du tableau
   si ncessaire, la capacit du tableau est augment */
void p_add(pool_t *pool, sp_t sp);


/* extraction du dernier sous-problme
   attention, cette fonction ne vrifie pas si le pool est vide */
sp_t p_extract(pool_t *pool);

#endif
